function grocer_listvar=dblist(grocer_filein,varargin)
 
// PURPOSE: gives the content of a database (simple but not
// elegant and, I presume, not efficient)
// ------------------------------------------------------------
// INPUT:
// * grocer_filein = name of the database
// * varargin = optional arguments hich can be:
//   - 'grocer_matlab' if the database is a grocer_matlab one (must be the
//   first variable argument
//   -
// ------------------------------------------------------------
// OUTPUT:
// * l = column vector containing the names of variables in the
// database
// ------------------------------------------------------------
// NOTES: this is an awful way to determine the content of a
// database, but it works and doing more efficient and elegant
// would imply for me too big an investment in scilab code...
// Obviously, if you have better at hand, I take it!
// ------------------------------------------------------------
// Copyright: Eric Dubois 2002-2009
// http://dubois.ensae.net/grocer.html
 
// set default options
[grocer_nargout,grocer_nargin]=argn(0)
grocer_matlab=%f
for grocer_i=grocer_nargin-1:-1:1
   if varargin(grocer_i) == 'grocer_matlab' then
      grocer_matlab=%t
      varargin(grocer_i)=[]
      grocer_nargin=grocer_nargin-1
   end
end
 
grocer_l=who('local')
 
if grocer_matlab then
   loadmatfile(grocer_filein)
else
   load(grocer_filein)
end
 
if exists('grocer_content','local') then
   grocer_listvar=grocer_content
 
else
 
   grocer_listvar=who('local')
   for grocer_i=size(grocer_listvar,'*'):-1:1
      if ~exists(grocer_listvar(grocer_i),'local') then
         grocer_listvar(grocer_i)=[]
      end
    end
   grocer_listvar(grocer_listvar == 'grocer_l')=[]
   grocer_listvar(grocer_listvar == 'grocer_nargin')=[]
   grocer_listvar(grocer_listvar == 'grocer_nargout')=[]
   grocer_listvar(grocer_listvar == 'grocer_filein')=[]
   grocer_listvar(grocer_listvar == 'grocer_fileout')=[]
   grocer_listvar(grocer_listvar == 'varargin')=[]
   grocer_listvar(grocer_listvar == 'grocer_matlab')=[]
   grocer_listvarn=unique(grocer_listvar)
   ndata=size(grocer_listvarn,'*')
   grocer_listvar=grocer_listvar(1:ndata)
 
end
 
if grocer_listvar(1,1) == 'VARIABLES' then
// true content after row 2
   deb=3
else
   deb=1
end
 
endnames=size(grocer_listvar,1)
indl=1:endnames
if grocer_nargin ~= 1 then
   indl=[1:deb-1]'
   for i=1:length(varargin)
      argi=varargin(i)
      length_argi=length(argi)
      sup=strindex(argi,'>')
      star=strindex(argi,'*')
 
      if ~isempty(sup) then
         for j=deb:endnames
            lj=grocer_listvar(j)
            if sup == 1 then
               indstr=strindex(lj,part(argi,2:length_argi))
               if ~isempty(indstr) & indstr > 1 then
                  indl=[indl ; j]
               end
 
            elseif sup == length_argi then
               indstr=strindex(lj,part(argi,1:length_argi-1))
               if ~isempty(indstr) & indstr < length(lj) then
                  indl=[indl ; j]
               end
            else
               indstr=strindex(lj,part(argi,2:length_argi-1))
               if ~isempty(indstr) & indstr >1 & indstr < length(lj) then
                  indl=[indl ; j]
               end
            end
         end
      end
 
      if ~isempty(star) then
      // just have to check if the strings other than '*' match
         ind=1:length(argi)
         ind(star)=[]
         argicut=part(argi,ind)
         for j=deb:endnames
            lj=grocer_listvar(j,1)
            if length(argi) == length(lj) then
               if part(lj,ind) == argicut then
                  indl=[indl ; j]
               end
            end
         end
      end
   end
   // remove the doublets
   if size(indl,1) > 1 then
      indl=gsort(indl,'g','i')
      dindl=indl(2:$)-indl(1:$-1)
      doubled=find(dindl ~= 0)
      indl=indl([1 doubled+1])
   end
   grocer_listvar=grocer_listvar(indl,:)
end
 
 
endfunction
 
