function retal = foreresid(retal,pred)

//----------------------------------------------------------
// fonction permettant prévision de la resid pour les 
// comptes provisoires et l'année en cours 
//-----------------------------------------------------------

N = size(retal('x trim'),1)
n = size(retal('x annu'),1)
s = retal('high freq')
u = retal('resid annu')
rho = retal('rho')

// recherche du nombre de prévisions à faire 

if (N-s*n+1)/s <= 1 then 
	nprev = 1
elseif (N-s*n+1)/s <= 2 & (N-s*n+1)/s > 1 
	nprev = 2 
else  (N-s*n+1)/s <= 3 & (N-s*n+1)/s > 2 
	nprev =3 
end 


// forecasting residuals

u_report = u 
for e = 1:nprev
	u_report = [u_report ; u(n)*(rho^e)]
end 
retal(1)($+1) = 'resid annu report'
retal('resid annu report') = u_report 
retal = lissquadra(retal,'report') 
retal('high freq resid')  =retal('high freq resid')(1:N)


endfunction

