function retal = lissquadra(retal,ind)

// ------------------------------------------------------------
//  Program that realizes:
//       Min sum[ ut(t)-ut(t-1) ]^2
//         w.r sum[ ut(t) ] = ua
// with ut high frequency residuals and ua annual ones
// ------------------------------------------------------------

if ind == 'full' then
    ua = retal('prov resid annu')
elseif ind == 'report' then     
    ua = retal('resid annu report')
else
    ua = retal('resid annu')
end 
n = size(ua,1)
s = retal('high freq')
 
//    generate matrices d and m such as:  
//            Min (d*ut)'(d*ut)               
//            s.c  m*ut = ua                


d = zeros(s*n-1,s*n) 
for i = 1:size(d,2)     
    d(i,i) = -1 ; d(i,i+1) = 1 
end 
m = eye(n,n) .*. ones(1,s)

//    generate matrices d and m such as:
//            Min (d*ut)'(d*ut)               
//            s.c  m*t*[ ut(1,1) d*ut ]' = ua                         

t = zeros(s*n,s*n) 
for i =1:size(t,1) 
    t(i,1:i) = 1
end  

// Lagrangian is:                   
//            L = (d*ut)'(d*ut) + 2*lambda'*[d*t*(ut(1,1) d*ut)' - ua]                 
//                  = (d*ut)'(d*ut) + 2*lambda'*[m1*ut(1,1)+mt*(d*ut)- ua]              


m1 = m*t* [ 1 ; zeros(s*n-1,1) ]
mt = m*t*[ zeros(1,s*n-1) ; eye(s*n-1,s*n-1) ]



//    First order conditions are:                        
//        (1) lambda'*m1 = 0                   
//        (2) d*ut = mt'*lambda       
//        (3) m1*ut(1,1)+mt*(d*ut) = ua                                            
//        hence:                     
//        (3') lambda = inv(mt*mt')*[ua-m1*ut(1,1)]                    


ut11 = (m1' * inv(mt * mt') * ua)/(m1' * inv(mt * mt') * m1 )
lambda = inv(mt * mt')*(ua - m1*ut11)
mx = (mt') * lambda

ut = t*[ut11 ; mx]

if ind == 'full' then
    retal(1)($+1) = 'prov high freq resid'
    N = size(retal('x trim aug'),1)
    retal('prov high freq resid') = ut(1:N)
else
    retal(1)($+1) = 'high freq resid'
    retal('high freq resid') = ut
end 

endfunction
