function gmmLin_d()
 
// PURPOSE: demo program for GMM estimation of a linear model
//    and performs tests of coefficient restrictions
 
 
 
disp('Demo program for GMM estimation of a  linear model')
disp('The model is y = X*b with b=[0;1;-1]')
disp('We will generate some data, estimate by OLS (using White SE), then')
disp('estimate by GMM and compare.')
 
lines(0);
X = [ones(1000,1) grand(1000,1,'nor',0,1) grand(1000,1,'nor',0,1)];
b = [0;1;-1];
e = grand(1000,1,'nor',0,1);
y = X*b + e;
 
olsout=hwhite(y,X);
 
disp(' Now we define a tlist variable to tell GMM what to do.')
gmmopt = tlist(['gmm';'momt';'jake';'prt';'gmmit';'S']);
gmmopt('prt')=1;
gmmopt('gmmit') = 1;
gmmopt('S')='W';
gmmopt('momt')='gmmLinM';
gmmopt('jake')='gmmLinJ';
 
disp('gmmopt is');
disp('');
disp(gmmopt);
 
disp('We need some starting values b0=zeros(3,1)');
b0=zeros(3,1);
//halt();disp('Strike a key to continue');
 
uout=gmm('y',gmmopt,'exo=''X''','ivar=''X''','parm0=b0');
 
halt();disp('Strike a key to continue');
disp('We will know perform some tests of parameter restriction');
disp('  we want to test if b3=0');
disp('');
br=[0;0];
bu = [0;0;0];
gmmopt('prt')=0;
 
disp('We will start with the D-test');
disp('We estimate the constrained model on the prior W');
disp('W0 = uout(''W'');  gmmopt(''W0'') = ''Win'';');
disp('rout=gmm(''y'',gmmopt,''exo=''X(:,2:3)'''',''ivar=''''X'''',''Win=W0'',''parm0=[0;0]'');');
disp('then we perfom the test: ');
disp('rd = gmmDtest(uout,rout,1)');
disp('');
W0 = uout('W');
gmmopt(1)($+1) = 'W0';
gmmopt('W0') = 'Win';
rout=gmm('y',gmmopt,'exo=''X(:,2:3)''','ivar=''X''','parm0=br','Win=W0','noprint');
rd = gmmDtest(uout,rout,1);
 
halt();disp('Strike A Key to Continue');
disp('Wald test using unconstrained estimates')
disp('R = [1 0 0]; r = 0;');
disp('rw=gmmWald(uout,R,r);');
disp('');
R = [1 0 0];
r = 0;
rw=gmmWald(uout,R,r);
 
disp('check if the non-linear Wald gives the same results')
disp('the constraint is written R=[''p1''] with p1 the first parameter');
disp('');
R = 'p1';
rw=gmmNlWald(uout,R);
 
halt();disp('Strike A Key to Continue');
disp('LM test using the unconstrained objective function at the constrained estimate');
disp('');
gmmopt('W0')='Z';
rout=gmm('y',gmmopt,'exo=''X(:,2:3)''','ivar=''X''','parm0=br','noprint');
rlm = gmmLM(uout,rout,[0,1,1],1);
 
 
endfunction
