function [dPhi,dGam,dE,dH,dD,dC,dQ,dS,dR] = ss_dvss(theta,theta2mat,i)
 
// SS_DVSS  - Computes the partial derivatives of the matrices of the SS
// representation with respect to the i-th parameter in THETA.
//    [dPhi, dGam, dE, dH, dD, dC, dQ, dS, dR] = ss_dvss(theta, din, i)
// This function only works with native SS models.
 
opt5_0=grocer_E4OPTION('var')
grocer_E4OPTION('var')='unfactorized'
 
[Phi,Gam,E,H,D,C,Q,S,R]=theta2ssss(theta,theta2mat)
 
theta(i)=theta(i)+1
 
 
[Phin,Gamn,En,Hn,Dn,Cn,Qn,Sn,Rn]=theta2ssss(theta,theta2mat)
dPhi=Phin-Phi
dGam=Gamn-Gam
dE=En-E
dH=Hn-H
dD=Dn-D
dC=Cn-C
dQ=Qn-Q
dS=Sn-S
dR=Rn-R
 
if opt5_0 == 'factorized' then
   dQ = Q*dQ'+dQ*Q';
   dR = R*dR'+dR*R';
end
 
endfunction
