function [grocer_nm_b,grocer_nm_f]=nelmead(grocer_nm_fkt,grocer_nm_x,grocer_nm_epsilon,grocer_nm_nitermax,varargin);
 
[nargout,nargin] = argn(0)
if nargin == 2 then
   grocer_nm_epsilon=1E-10;
    grocer_nm_nitermax=%inf;
   varargin= list()
end
 
grocer_nm_alpha=1;
grocer_nm_bet=0.5;
grocer_nm_gam=2;
grocer_nm_p = size(grocer_nm_x,1);
 
// Step A: Intialisation of simplex
// and computing function values
 
grocer_nm_s = [grocer_nm_x (ones(1,grocer_nm_p).*.grocer_nm_x + 0.1*eye(grocer_nm_p,grocer_nm_p))]
grocer_nm_f = zeros(grocer_nm_p+1,1);
 
for grocer_nm_i=1:grocer_nm_p+1
   grocer_nm_f(grocer_nm_i)=grocer_nm_fkt(grocer_nm_s(:,grocer_nm_i),varargin(:))
end
 
grocer_nm_niter=1
grocer_nm_sctd0=stdc(grocer_nm_f)*2
while stdc(grocer_nm_f) > grocer_nm_epsilon & stdc(grocer_nm_f) ~= grocer_nm_sctd0 & grocer_nm_niter < grocer_nm_nitermax
   grocer_nm_niter=grocer_nm_niter+1
   grocer_nm_sctd0=stdc(grocer_nm_f)
   grocer_nm_fs=[grocer_nm_f grocer_nm_s']
 
// Step B: Ordering
   [grocer_nm_v,grocer_nm_indv]=gsort(grocer_nm_fs(:,1),'g','i')
   grocer_nm_f=grocer_nm_fs(grocer_nm_indv,1)
   grocer_nm_s=grocer_nm_fs(grocer_nm_indv,2:$)'
   grocer_nm_xo=mean0(grocer_nm_s(:,1:grocer_nm_p),'c')
 
// Step C: Compute Centroid
   grocer_nm_fo=grocer_nm_fkt(grocer_nm_xo,varargin(:))
   grocer_nm_xr=grocer_nm_xo + grocer_nm_alpha*(grocer_nm_xo-grocer_nm_s(:,grocer_nm_p+1))
   grocer_nm_fr=grocer_nm_fkt(grocer_nm_xr,varargin(:))
 
// Step D: Reflection
 
   if grocer_nm_fr < grocer_nm_f(1) then
 
// Step E: Comparison of fo with min-f and substitution of edge with max-f
      grocer_nm_xe=grocer_nm_xo+grocer_nm_gam*(grocer_nm_xr-grocer_nm_xo)
      grocer_nm_fe=grocer_nm_fkt(grocer_nm_xe,varargin(:))
//
      if grocer_nm_fe < grocer_nm_f(1) then
         grocer_nm_s(:,grocer_nm_p+1)=grocer_nm_xe;
         grocer_nm_f(grocer_nm_p+1)=grocer_nm_fe;
      else
// if improvement occurs
         grocer_nm_s(:,grocer_nm_p+1)=grocer_nm_xr;
         grocer_nm_f(grocer_nm_p+1)=grocer_nm_fr;
      end
 
   elseif grocer_nm_fr < grocer_nm_f(grocer_nm_p) then
      grocer_nm_s(:,grocer_nm_p+1)=grocer_nm_xr
      grocer_nm_f(grocer_nm_p+1)=grocer_nm_fr
 
   else
      if grocer_nm_fr < grocer_nm_f(grocer_nm_p+1) then
 
// Step F: Contraction
         grocer_nm_s(:,grocer_nm_p+1)=grocer_nm_xr
         grocer_nm_f(grocer_nm_p+1)=grocer_nm_fr;
      end
      grocer_nm_xc=grocer_nm_xo + grocer_nm_bet*(grocer_nm_s(:,grocer_nm_p+1)-grocer_nm_xo)
      grocer_nm_fc=grocer_nm_fkt(grocer_nm_xc,varargin(:))
 
      if grocer_nm_fc < grocer_nm_f(grocer_nm_p+1) then
 
// Step G: Comparison
         grocer_nm_s(:,grocer_nm_p+1)=grocer_nm_xc
         grocer_nm_f(grocer_nm_p+1)=grocer_nm_fc
      else
 
// Step H: Reducing the size
         grocer_nm_s=0.5*(grocer_nm_s+grocer_nm_s(:,1:grocer_nm_p+1));
         for grocer_nm_i=2:grocer_nm_p+1;
            grocer_nm_f(grocer_nm_i)=grocer_nm_fkt(grocer_nm_s(:,i),varargin(:))
         end
      end
   end
end
 
grocer_nm_b=grocer_nm_s(:,1)
grocer_nm_f=grocer_nm_f(1)
 
endfunction
