function pltdensbma_g(res)
 
// PURPOSE: prints the posterior density function of coefficient
// ------------------------------------------------------------
// OUPTUT:
// nothing: all results are printed on the specified file
// ------------------------------------------------------------
// NOTES:
// used by the following function:
//	bma_g()
// ---------------------------------------------------
// Copyright E. Michaux (2004)
 
nbet = res('nvar')-1
bet = res('beta')
allbeta = res('all beta')
 
vprob = res('vprob')
namex = res('namex')
 
intn = int(sqrt(nbet))
 
ng=winsid()  												// get lisy of opened windows
ng = ng(size(ng,2))+1
xset("window",ng)
clf(ng)
 
subplot(intn+1,intn+1,1)	
plot2d([],[],axesflag=0)
titlepage(["Posterior density functions";"incl. probability > 5%"])
pos = 2
 
for i = 1:nbet
	
	if vprob(i) > 0.05 then
		ibet =find(allbeta(:,i) ~= 0)
		sbet = allbeta(ibet',i)
 
		if size(sbet,1) > 4 then
		
			subplot(intn+1,intn+1,pos)	
			histplot(30,sbet,normalization=%t)
			xtitle(["Variable "+namex(i);"av. :"+string(bet(i))+" prob. :"+string(vprob(i))])
			pos = pos+1
 
		end
	end
end
 
endfunction
