function [num,fq]=date2num_fq(dat,varargin)
 
// PURPOSE:  return the numerical representation and the
// frequency of a date
// ------------------------------------------------------------
// INPUT:
// * dat = a date string
// * varargin = 'w' if the date is given as a day date but
//   corresponds to a week
// ------------------------------------------------------------
// OUTPUT:
// * num = the numerical representation of the date
// * fq = its (2x1) frequency
// ------------------------------------------------------------
// Copyright: Eric Dubois 2005-2007
// http://dubois.ensae.net/grocer.html
 
global GROCERDIR ;
 
load(GROCERDIR+'\param\basets.dat')
 
[fq,fqlit]=date2fq(dat,varargin(:))
		
if fqlit == 'da' then
   load(GROCERDIR+'\param\dailyform.dat')
   ind=strindex(dat,grocer_dailysep)
   p=evstr([part(dat,1:ind(1)-1) ; part(dat,ind(1)+1:ind(2)-1) ; part(dat,ind(2)+1:length(dat))])
   num=datenum(p(grocer_dailypart(1)),p(grocer_dailypart(2)),p(grocer_dailypart(3)))
 
elseif fqlit =='w' then
   load(GROCERDIR+'\param\dailyform.dat')
   ind=strindex(dat,grocer_dailysep)
   p=evstr([part(dat,1:ind(1)-1) ; part(dat,ind(1)+1:ind(2)-1) ; part(dat,ind(2)+1:length(dat))])
   num=int((datenum(p(grocer_dailypart(1)),p(grocer_dailypart(2)),p(grocer_dailypart(3)))-3)/7)
 
 
else
   ind=strindex(dat,fqlit)
   if isempty(ind) then
      if and(ascii(dat) >= 46) & and(ascii(dat) <= 57) then
         num=evstr(dat)
      else
         error('not an available date: '+dat)
      end
 
   elseif fq(1) == 1 then
      num=evstr(part(dat,1:ind-1))
 
   elseif fq(2) == 1 then
 
      if fqlit == 'f' then
         p=evstr(part(dat,strindex(dat,'d')+1:length(dat)))
      else
         p=evstr(part(dat,ind+1:length(dat)))
      end
 
      if p > fq(1) then
         error('period is greater than frequency')
      else
         num=evstr(part(dat,1:ind-1))*fq(1)+p
      end
 
   else
      num=evstr(part(dat,1:ind-1))
 
   end
end
 
endfunction
