function [tsmat1]=%tsmat_c_tsmat(tsmat1,tsmat2)
 
// PURPOSE: operates the addition of 2 tsmat;
// the overloading capability of scilab allows then one to
// write tsmat1+tsmat2 to do the addition
// ------------------------------------------------------------
// INPUT:
// * tsmat1 = a tlist of type tsmat
// * tsmat2 = a tlist of type tsmat
// ------------------------------------------------------------
// OUTPUT:
// * tsmat1 = the sum of 2 tsmat
// ------------------------------------------------------------
// NOTES:
// ------------------------------------------------------------
// Copyright: Eric Dubois & Emmanuel Michaux 2008
// http://dubois.ensae.net/grocer.html
 
global GROCERDIR ;
 
f1=tsmat1('freq')
if f1 ~= tsmat2('freq') then
   error('timeseries have not the same frequency')
end
 
d1=tsmat1('dates')
d2=tsmat2('dates')
d1f=d1(1)
d1l=d1($)
d2f=d2(1)
d2l=d2($)
 
s1=tsmat1('series')
s2=tsmat2('series')
ns1=size(s1,2) 
ns2=size(s2,2) 

name1= tsmat1('names')
name2= tsmat2('names')

ind2=1:ns2
if name2 == 'var'+string(ind2)' then
   name2='var'+string(ns1+ind2)'
else
   for i=ns2:-1:1
      if or(name1 == name2(i)) then
         warning('a variable with name '+name2(i)+' in both tsmat: the 2nd one has been removed')
         ind2(i) = []
      end
   end
end
ns2=size(ind2,2)
// determines the commun time span of the 2 series
datfirst=min(d1f,d2f)
datlast=max(d1l,d2l)
dataux=[datfirst:datlast]'
ndates=datlast-datfirst+1
       
s=%nan*ones(ndates,ns1+ns2)
s([d1f:d1l]-datfirst+1,1:ns1)=s1
if ns2 ~= 0 then
    s([d2f:d2l]-datfirst+1,ns1+ind2)=s2(:,ind2)
end
// for the sake of speed, fill the timeseries tsmat1 with the results
// of concatenation

tsmat1('dates')=[datfirst:datlast]'
tsmat1('series')=s
tsmat1('names') = [ name1 ; name2 ]
  
endfunction
