function %tsmat_p(tsmat)
 
// PURPOSE: provide a user friendly display of tsmat
// ------------------------------------------------------------
// INPUT:
// * boun = a vector of bounds
// * varargin = time series
// ------------------------------------------------------------
// OUTPUT:
// * tsmat= a tlist of type tsmat
// ------------------------------------------------------------
// Copyright Eric Dubois 2008
// http://dubois.ensae.net/grocer.html
 
s=tsmat('series')
fq=tsmat('freq')
dat=tsmat('dates')
nam=tsmat('names')
 
if fq == [365 1] then
   indnonna=or(~isnan(s),'c')
   dat=dat(indnonna)
   s=s(indnonna,:)
end
 
s=[nam' ; string(s)]
datlit=[' ' ; num2date(dat,fq) ]
 
L1=max(length(datlit)) ;
L2=max(length(s)) ;
t=part(datlit,1:L1+1)
for i=1:size(s,2)
// do the concatenation of the columns
   t=t+part(s(:,i),1:L2+1)
end
 
write(%io(2),t,'(a)')
 
endfunction
 
